// M163 Vulcan (Dessert Storm)
// By Pandoras Box	
// sf_pandorasbox@hotmail.com

// some basic defines
#define TEast 0
#define TWest 1
#define TGuerrila 2
#define TCivilian 3
#define TSideUnknown 4
#define TEnemy 5
#define TFriendly 6
#define TLogic 7

#define true 1
#define false 0

// type scope
#define private 0
#define protected 1
#define public 2

#define CanSeeRadar 1
#define CanSeeEye 2
#define CanSeeOptics 4
#define CanSeeEar 8
#define CanSeeCompass 16 
#define CanSeeRadarC CanSeeRadar+CanSeeCompass
#define CanSeeAll 31

class CfgPatches
{
	class PDBM163VULCAN
	{
		units[] = {PDBM163VULCAN};
		weapons[] = {};
		requiredVersion = 1.01;
	};
};

class CfgAmmo
{
	class Default {};
	class BulletSingle : Default {};
	class BulletM168AP: BulletSingle {
		 // in fact this is 5 bullets burst
		// normall bullets
		hit=40;indirectHit=10;indirectHitRange=2;
		minRange=20;minRangeProbab=0.80;
		midRange=500;midRangeProbab=0.95;
		maxRange=3000;maxRangeProbab=0.05;
		cost=30;
	};
		class ExplosiveBullet: BulletSingle {};
		class BulletM168HE: ExplosiveBullet {
		 // in fact this is 5 bullets burst
		// explosive bullets
		hit=30;indirectHit=20;indirectHitRange=10;
		minRange=20;minRangeProbab=0.80;
		midRange=500;midRangeProbab=0.95;
		maxRange=3000;maxRangeProbab=0.05;
		cost=30;
	};
};

class CfgWeapons
{
	class Default	{};
	class MGun: Default {};
	class MachineGun7_6: MGun {};
	class MachineGun30: MachineGun7_6 {};
	class M168AP: MachineGun30
	{
		ammo=BulletM168AP;
		count=1200;
		initSpeed=1100;
		flashSize=1.2;
		reloadTime=0.001;
		displayName = M168 AP;
		displayNameMagazine = M168 AP;
		shortNameMagazine = M168 AP;
                sound[]={"\PDB M163Vulcan\Vulcan.wav",db-10,1};
                soundContinuous=true;
		dispersion=0.0015;
		maxLeadSpeed=900; // max estimated speed km/h

		aiRateOfFire=5; // delay between shots at given distance
		aiRateOfFireDistance=3000; // at shorter distance delay goes lineary to zero
	};

	
	class M168HE: MachineGun30
	{
		ammo=BulletM168HE;
		count=1200;
		initSpeed=800;
		flashSize=1.2;
		reloadTime=0.001;
		displayName = M168 HE;
		displayNameMagazine = M168 HE;
		shortNameMagazine = M168 HE;
                sound[]={"\PDB M163Vulcan\Vulcan.wav",db-10,1};
                soundContinuous=true;
		dispersion=0.0015;
		maxLeadSpeed=900; // max estimated speed km/h

		aiRateOfFire=5; // delay between shots at given distance
		aiRateOfFireDistance=3000; // at shorter distance delay goes lineary to zero
	};
};

class CfgVehicles
{
	class All {};
	class AllVehicles: All {};
	class Land: AllVehicles {};
	class LandVehicle: Land {};
	class Tank: LandVehicle
	{
		class TurretBase {};
	};
	class APC: Tank {};
	class M113: APC {};

	class PDBM163VULCAN: M113
	{
		displayName=PDB M163_Vulcan;
		picture=\PDB M163Vulcan\vulcandessert\ivulcan.paa;
		icon = antiAC.paa;
		armor=250;
		cost=1000000;
		model=\PDB M163Vulcan\PDB M163Vulcan;
                SoundEngine[]={"\PDB M163Vulcan\m113.wav",db+10,1};
		irScanRange = 4000; // long range radar
		irScanGround = false;  // NO IR on ground targets
		gunnerCanSee = CanSeeOptics+CanSeeEar+CanSeeCompass+CanSeeRadar;
		weapons[]={M168AP,M168HE};
		magazines[]={M168AP,M168HE};
		class Turret: TurretBase
		{
			minElev=-3;
			maxElev=+70;
		};
		//threat[] VSoft, VArmor, VAir 
		threat[]={0.5, 0.5, 1};
		gunnerOpticsModel = "optika_zsu_gunner";
		commanderOpticsModel = "optika_tanke_auxiliary";

		gunnerAction = ManActVulcanGunner;
		gunnerInAction = ManActVulcanGunner;

		// outGunnerMayFire = true;
		forceHideGunner = true;
		viewGunnerInExternal = true;
		transportSoldier = 2;
	};
};

class CfgNonAIVehicles
{
	class ProxyCrew {};
	class Proxygunner: ProxyCrew {};
	class Proxyvulcangunner: Proxygunner {};
};

#define SPEED_STATIC 1e10

class CfgVehicleActions
{
	vulcangunner = "vulcangunner";
};

class CfgMovesMC
{
	class Default {};
	class DefaultDie: Default {};

	class States
	{
		class Driver: Default {};

		#define VEH_DIE_CONN(Name,anim,time) \
			class Name##Dying: DefaultDie \
			{ \
				actions = NoActions; \
				file=anim##smrt.rtm; \
				speed=-time; \
				looped=false; \
				soundEnabled=false; \
				connectFrom[]={Name,1}; \
			}; \
			class Name##Dead: Name##Dying \
			{ \
				actions = DeadActions; \
				file=anim##smrt2.rtm; \
				speed=SPEED_STATIC; \
				terminal = true; \
				connectFrom[]={Name##Dying,1}; \
				connectTo[]={DeadState,1}; \
			}
		#define VEHIN_MOVES_VAR(Name,anim,vartime) \
			class Name: Driver \
			{ \
				file=anim##stat.rtm; \
				speed=SPEED_STATIC; \
				looped=true; \
				variantsAI[]= {Name##V1,0.7,Name};\
				interpolateWith[]={Name##V1,0.5};\
				equivalentTo=Name; \
				interpolationSpeed=1; \
				connectTo[]={Name##Dying,1}; \
			} \
			class Name##V1: Name \
			{ \
				file=anim.rtm; \
				speed=-vartime; \
				looped=true; \
			}
		#define VEH_MOVES_VAR(Name,anim,time,vartime) \
			VEHIN_MOVES_VAR(Name,anim,vartime); \
			VEH_DIE_CONN(Name,anim,time)

		VEH_MOVES_VAR(VulcanGunner, \vulcan\vulcangunner, 1, 4);
	};
};
